
/* EXAMPLE CODE - DSP1610 COMPLEX FIR FILTER */

.rsect ".ram"
		       goto start
.=0x1
int_0:  goto interpt0           

start:  auc=0x0
	a0=0
	a1=0
	r1=datay
	pt=datax
		r2=0x7f00               /* 7f00 = re(in),  7f01 = im(in),   */
                                        /* 7f02 = re(out), 7f03 = im(out)   */
		rb=datay                /* set up modulo addressing         */
		re=end
		r3=flag
		inc=0x10

loop:           nop
		nop
		goto loop

filter:		pt=datax
                                        y=*r1++ x=*pt++
				p=x*y           y=*r1--      /* P=RE*RE */
		do 5{
		a0=a0+p p=x*y           y=*r1++ x=*pt++      /* P=IM*RE */
		a1=a1+p p=x*y           y=*r1++              /* P=RE*IM */
		a1=a1+p p=x*y           y=*r1++ x=*pt++      /* P=IM*IM */
		a0=a0-p p=x*y           y=*r1--              /* P=RE*RE */
		}


		*r2++=a0                /* OUTPUT REAL                  */
		*r2=a1                  /* OUPUT IM                     */
		r2=0x7f00               /*  reset pointer               */
		a0=a0^a0
		*r3=a0                  /* reset flag                   */
		ireturn                 /* wait for next interupt       */

interpt0:       a0=*r2++                /* INPUT REAL                   */
		*r1++=a0                /* store real                   */
		a0=*r2++                /* INPUT IM                     */
		*r1++=a0                /* store im                     */
		a0=*r3
		a0h-0x1                 /* check flag                   */
		if eq goto filter
		a0=a0+1                 /* increment flag               */
		*r3=a0l
		ireturn
datax:          int 1,1,1,1,1,1,1,1,1,1,1,1    /* RE,IM,RE,IM,RE,IM.... */
.=0x400                         /* Second 1k bank for Y space   */
datay:          int 2,2,2,2,2,2,2,2,2,2,2,2    /* RE,IM,RE,IM.......*/
end:            int
flag:		int
		
.rsect ".eram"
.=0x7f00
	4*int

/*
 * This program will wait for int0 and then will take in 2 data
 * values from the I/O space, 0x7f00 & 7f01, and store them to memory.
 * If the flag pointed to by r3 is 0x1 the filter routine will execute,
 * otherwise you will return and wait for the next interrupt. When the
 * filter routine has executed the results will be sent to the I/O
 * space 7f02 & 7f03. From the time you take int0 until you return
 * to loop (assuming the flag is set so that you goto the filter
 * routine) will take 36+4N cycles.
 */
